from Aircombat_env import AirCombatEnv
from Agent import DQN
import xlwt
import time
import tensorflow as tf


EPISODE = 60001             # Maximum episodes
STORE = 10000               # Running for replay buffer
TEST = 100                  # Number of test episodes
TRAIN = 100                 # Training interval

# Data saving configuration
workbook = xlwt.Workbook(encoding='utf-8')
showbook = xlwt.Workbook(encoding="utf-8")
trainsheet = workbook.add_sheet('train', cell_overwrite_ok=True)        # Training data sheet
showsheet = showbook.add_sheet('show',cell_overwrite_ok=True)           # Test data sheet
row0 = [u'episode',u'step',u'reward',u'b_success',u'r_success',u'draw']
row1 = ['PATH_NUM', 'b_x', 'b_y', 'b_heading', 'b_bank', 'r_x', 'r_y', 'r_heading', 'r_bank',
        'ATA_b', 'AA_b', 'ATA_r', 'AA_r']
for i in range(len(row0)):
    trainsheet.write(0, i, row0[i])
    showsheet.write(0, i, row0[i])


def run_AirCombat_selfPlay(train_agent, use_agent, train_agent_name):  
    """
        train_agent:        Class object
        use_agent:          Class object
        train_agent_name:   str
    """
    def _env_reset(train_agent_name):
        state_blue, state_red = env.reset_selfPlay()
        state_train_agent, state_use_agent = _alloc_state(state_blue, state_red, train_agent_name)
        return state_train_agent, state_use_agent

    def _env_step(action_train_agent, action_use_agent, train_agent_name):
        action_blue, action_red = _alloc_action(action_train_agent, action_use_agent, train_agent_name)
        next_state_blue, next_state_red, reward_b, reward_r, done = env.step_selfPlay(action_blue, action_red) # todo-levin: 设置两种state，还是设置统一使用的state
        next_state_train_agent, next_state_use_agent = _alloc_state(next_state_blue, next_state_red, train_agent_name)
        reward_train_agent, reward_use_agent = _alloc_reward(reward_b, reward_r,train_agent_name)
        return next_state_train_agent, next_state_use_agent, reward_train_agent, done

    def _alloc_state(state_blue, state_red, train_agent_name):
        if train_agent_name == 'blue':
            state_train_agent = state_blue
            state_use_agent   = state_red
        else:
            state_train_agent = state_red
            state_use_agent   = state_blue
        return state_train_agent, state_use_agent

    def _alloc_reward(reward_b, reward_r,train_agent_name):
        if train_agent_name == 'blue':
            reward_train_agent = reward_b
            reward_use_agent   = reward_r
        else:
            reward_train_agent = reward_r
            reward_use_agent   = reward_b
        return reward_train_agent, reward_use_agent

    def _alloc_action(action_train_agent, action_use_action, train_agent_name):
        if train_agent_name == 'blue':
            action_blue = action_train_agent
            action_red  = action_use_action
        else:
            action_blue = action_use_action
            action_red  = action_train_agent
        return action_blue, action_red

    # ====  loop start ====
    if train_agent.IsTrain:       # Training phase
        suc_num = 0

        # Save data to replay buffer
        env.init_scen = 0
        for episode in range(STORE):
            # reset
            state_train_agent, state_use_agent = _env_reset(train_agent_name)

            if episode % 100 == 0:
                print('data collection: {} ,buffer capacity: {} '.format(episode / 100,
                                                                         len(train_agent.replay_buffer)))
            while True:
                # action
                action_train_agent = train_agent.egreedy_action(state_train_agent)
                action_use_agent = use_agent.action(state_use_agent)

                # next_state
                next_state_train_agent, next_state_use_agent, reward_train_agent, done = _env_step(action_train_agent, action_use_agent, train_agent_name)
                train_agent.store_data(state_train_agent, action_train_agent, reward_train_agent, next_state_train_agent, done)
                state_train_agent = next_state_train_agent
                if done:
                    break
            if(len(train_agent.replay_buffer) >= 100000):
                break

        #Training
        for episode in range(EPISODE):
            env.init_scen = 0           # random_initialization
            total_reward = 0            #total reward
            step = 0                    #step
            state_train_agent, state_use_agent = _env_reset(train_agent_name)
            while True:
                action_train_agent = train_agent.egreedy_action(state_train_agent)      # choose action
                action_use_agent = use_agent.action(state_use_agent)
                next_state_train_agent, next_state_use_agent, reward, done = \
                    _env_step(action_train_agent, action_use_agent, train_agent_name)

                total_reward += reward
                train_agent.perceive(state_train_agent, action_train_agent, reward, next_state_train_agent, done)   #learning
                state_train_agent = next_state_train_agent
                step += 1
                if done:
                    print('Episode: ', episode, 'Step', step, "Reward:", total_reward, 'Success',env.success,'Advantage',env.advs)
                    break

            # Test episodes
            if (episode % TRAIN == 0):
                train_agent.saver.save(train_agent.session, train_agent_name + '_saved_networks/' + '-dqn', global_step=episode)
                total_reward = 0
                total_step = 0
                blue_suc_count = 0
                red_suc_count = 0
                draw_count = 0
                for i in range(TEST):
                    state_train_agent, state_use_agent = _env_reset(train_agent_name)
                    step = 0
                    total_reward = 0
                    #env.creat_ALG()         # visualization
                    """
                    testsheet = workbook.add_sheet('trace' + str(int(episode/TRAIN * TEST + i + 1)), cell_overwrite_ok=True)
                    for j in range(len(row1)):
                        testsheet.write(0, j, row1[j])
                    testsheet.write(step + 1, 0, step + 1)
                    testsheet.write(step + 1, 1, float(env.pos[0]))
                    testsheet.write(step + 1, 2, float(env.pos[1]))
                    testsheet.write(step + 1, 3, float(env.heading))
                    """
                    while True:
                        action_train_agent = train_agent.action(state_train_agent)
                        action_use_agent = use_agent.action(state_use_agent)
                        state_train_agent, state_use_agent, reward, done = _env_step(action_train_agent, action_use_agent, train_agent_name)

                        total_reward += reward
                        total_step += 1
                        total_reward += reward
                        step += 1
                        #env.render()        # visualization
                        """
                        testsheet.write(step + 1, 0, step + 1)
                        testsheet.write(step + 1, 1, float(env.pos[0]))
                        testsheet.write(step + 1, 2, float(env.pos[1]))
                        testsheet.write(step + 1, 3, float(env.heading))
                        """
                        if done:
                            if env.success == 1:
                                blue_suc_count += 1
                            elif env.success == -1:
                                red_suc_count += 1
                            else:
                                draw_count += 1

                            break
                ave_reward = total_reward / TEST        # average reward
                ave_step = total_step / TEST            # average step
                trainsheet.write(int(episode / TRAIN + 1), 0, (episode / TRAIN + 1))
                trainsheet.write(int(episode / TRAIN + 1), 1, ave_step)
                trainsheet.write(int(episode / TRAIN + 1), 2, ave_reward)
                trainsheet.write(int(episode / TRAIN + 1), 3, blue_suc_count)
                trainsheet.write(int(episode / TRAIN + 1), 4, red_suc_count)
                trainsheet.write(int(episode / TRAIN + 1), 5, draw_count)
                workbook.save(train_agent_name + '_data_train'  + '.xls')
                print('Episode: ', episode, "Blue success count:", blue_suc_count, "Red success count:", red_suc_count, "Draw count:", draw_count, "Average Reward:", ave_reward)
                if train_agent_name == 'blue':
                    if blue_suc_count >= 0.55 * TEST and red_suc_count <= 0.05 * TEST:
                        suc_num += 1
                    else:
                        suc_num = 0
                else:
                    if red_suc_count >= 0.55 * TEST and blue_suc_count <= 0.05 * TEST:
                        suc_num += 1
                    else:
                        suc_num = 0
                if suc_num == 2:
                    break

    else:    # agent using
        for episode in range(EPISODE):
            env.init_scen = 0
            total_reward = 0
            step = 0

            # Data saving configuration
            tracesheet = showbook.add_sheet('trace' + str(episode + 1), cell_overwrite_ok=True)
            for i in range(len(row1)):
                tracesheet.write(0, i, row1[i])

            state_blue, state_red = env.reset_selfPlay()
            state_train_agent, state_use_agent = _alloc_state(state_blue, state_red, train_agent_name)
            env.creat_ALG()
            tracesheet.write(step + 1, 0, step + 1)
            tracesheet.write(step + 1, 1, float(env.ac_pos_b[0]))
            tracesheet.write(step + 1, 2, float(env.ac_pos_b[1]))
            tracesheet.write(step + 1, 3, float(env.ac_heading_b))
            tracesheet.write(step + 1, 4, float(env.ac_bank_angle_b))
            tracesheet.write(step + 1, 5, float(env.ac_pos_r[0]))
            tracesheet.write(step + 1, 6, float(env.ac_pos_r[1]))
            tracesheet.write(step + 1, 7, float(env.ac_heading_r))
            tracesheet.write(step + 1, 8, float(env.ac_bank_angle_r))
            tracesheet.write(step + 1, 9, float(env.ATA_b))
            tracesheet.write(step + 1, 10, float(env.AA_b))
            tracesheet.write(step + 1, 11, float(env.ATA_r))
            tracesheet.write(step + 1, 12, float(env.AA_r))

            while True:
                action_train_agent = train_agent.action(state_train_agent)
                action_use_agent = use_agent.action(state_use_agent)

                state_train_agent, state_use_agent, reward, done = \
                    _env_step(action_train_agent, action_use_agent, train_agent_name)

                total_reward += reward
                step += 1
                env.render()
                tracesheet.write(step + 1, 0, step + 1)
                tracesheet.write(step + 1, 1, float(env.ac_pos_b[0]))
                tracesheet.write(step + 1, 2, float(env.ac_pos_b[1]))
                tracesheet.write(step + 1, 3, float(env.ac_heading_b))
                tracesheet.write(step + 1, 4, float(env.ac_bank_angle_b))
                tracesheet.write(step + 1, 5, float(env.ac_pos_r[0]))
                tracesheet.write(step + 1, 6, float(env.ac_pos_r[1]))
                tracesheet.write(step + 1, 7, float(env.ac_heading_r))
                tracesheet.write(step + 1, 8, float(env.ac_bank_angle_r))
                tracesheet.write(step + 1, 9, float(env.ATA_b))
                tracesheet.write(step + 1, 10, float(env.AA_b))
                tracesheet.write(step + 1, 11, float(env.ATA_r))
                tracesheet.write(step + 1, 12, float(env.AA_r))

                if done:
                    showsheet.write(episode + 1, 0, episode + 1)
                    showsheet.write(episode + 1, 1, (step + 1) * 0.5)
                    showsheet.write(episode + 1, 2, total_reward)
                    showsheet.write(episode + 1, 3, env.disadvantage)
                    print('Episode: ', episode, 'Step', step, "Reward:", total_reward,"Success:", env.success,env.acts)
                    break
            showbook.save(train_agent_name + '_data_show' + '.xls')


def _check_scheme(IsTrain_1, IsTrain_2, train_agent_name):
    if IsTrain_1 ^ IsTrain_2:
        print("\n === train " + train_agent_name + " agent ===\n")
    elif IsTrain_1 | IsTrain_2:
        print("\n!!! Error: both agent is training !!!\n")
    else:
        print("\n === test " + train_agent_name + " agent ===\n")
        

if __name__ == "__main__":
    env = AirCombatEnv()

    flag_IsTrain = 0        # 1: Train; 0: Use
    flag_train_blue = 1     # 1: Train Blue; 0: Train Red

    with tf.Session() as sess:
        if flag_IsTrain:
            # set training agent
            if flag_train_blue:
                blue_agent = DQN(IsTrain=True, scope='blue', sess=sess)
                red_agent  = DQN(IsTrain=False, scope='red', sess=sess)
                sess.run(tf.global_variables_initializer())
                blue_agent.load_parms()
                red_agent.load_parms()
                train_agent_name = 'blue'
                _check_scheme(blue_agent.IsTrain, red_agent.IsTrain, train_agent_name)
                run_AirCombat_selfPlay(blue_agent, red_agent, train_agent_name)
            else:
                blue_agent = DQN(IsTrain=False, scope='blue', sess=sess)
                red_agent  = DQN(IsTrain=True, scope='red', sess=sess)
                sess.run(tf.global_variables_initializer())
                blue_agent.load_parms()
                red_agent.load_parms()
                train_agent_name = 'red'
                _check_scheme(blue_agent.IsTrain, red_agent.IsTrain, train_agent_name)
                run_AirCombat_selfPlay(red_agent, blue_agent, train_agent_name)

        else:
            blue_agent = DQN(IsTrain=False, scope='blue', sess=sess)
            red_agent  = DQN(IsTrain=False, scope='red', sess=sess)
            sess.run(tf.global_variables_initializer())

            blue_agent.load_parms()
            red_agent.load_parms()

            if flag_train_blue:
                train_agent_name = 'blue'
                _check_scheme(blue_agent.IsTrain, red_agent.IsTrain, train_agent_name)
                run_AirCombat_selfPlay(blue_agent, red_agent, train_agent_name)
            else:
                train_agent_name = 'red'
                _check_scheme(blue_agent.IsTrain, red_agent.IsTrain, train_agent_name)
                run_AirCombat_selfPlay(red_agent, blue_agent, train_agent_name)